import "./form-input-number.css";
import { defineComponent as V, resolveDirective as N, openBlock as n, createElementBlock as o, mergeProps as f, createElementVNode as r, normalizeClass as d, toDisplayString as c, createCommentVNode as m, withModifiers as k, renderSlot as D, withDirectives as S, vModelText as I, createBlock as b, resolveDynamicComponent as g, Fragment as y, createTextVNode as $ } from "vue";
import { U as F } from "../../maska-e074d7a3.js";
import { p as L } from "../../helper-4d4ed314.js";
import { s as P, e as M } from "../../icons-fca12ed8.js";
import { _ as v } from "../../_plugin-vue_export-helper-dad06003.js";
const w = V({
  emits: {
    "update:modelValue": (e) => !0,
    blur: (e) => !0,
    change: (e) => !0,
    focus: (e) => !0,
    input: (e) => !0,
    keydown: (e) => !0
  },
  props: {
    autocomplete: {
      required: !1,
      type: Boolean
    },
    disabled: {
      required: !1,
      type: Boolean
    },
    errorMessage: {
      required: !1,
      type: [String, Function]
    },
    icon: {
      required: !1,
      type: Object
    },
    invalidNumberMessage: {
      default: "Please enter valid numbers",
      type: String
    },
    isError: {
      required: !1,
      type: Boolean
    },
    isFocus: {
      required: !1,
      type: Boolean
    },
    label: {
      required: !1,
      type: String
    },
    max: {
      required: !1,
      type: Number
    },
    maxDecimalPlaces: {
      default: 10,
      type: Number
    },
    min: {
      required: !1,
      type: Number
    },
    modelValue: {
      required: !1,
      type: null
    },
    numberLocale: {
      default: "en-US",
      type: String
    },
    placeholder: {
      required: !1,
      type: String
    },
    readOnly: {
      required: !1,
      type: Boolean
    },
    required: {
      required: !1,
      type: Boolean
    },
    step: {
      default: 1,
      type: Number
    },
    tabindex: {
      required: !1,
      type: Number
    },
    textAlign: {
      default: "left",
      type: String
    },
    value: {
      required: !1,
      type: null
    },
    variant: {
      default: "default",
      required: !1,
      type: String
    },
    withLocale: {
      default: !1,
      type: Boolean
    }
  },
  name: "sb-form-input",
  directives: {
    maska: F
  },
  data() {
    return {
      localIsFocus: !1,
      isInvalidNumber: !1,
      localValue: this.modelValue || this.value || null
    };
  },
  computed: {
    getMaskaOptions() {
      if (!this.withLocale) {
        const e = [
          ...Array(this.maxDecimalPlaces).keys()
        ].map(() => "9").join("");
        return this.maxDecimalPlaces ? {
          mask: `#0.${e}`,
          preProcess: (t) => String(t),
          tokens: {
            "#": {
              optional: !0,
              pattern: /-/
            },
            0: {
              multiple: !0,
              pattern: /[0-9]/
            },
            9: {
              optional: !0,
              pattern: /[0-9]/
            }
          }
        } : {
          mask: "#0",
          preProcess: (t) => String(t),
          tokens: {
            "#": {
              optional: !0,
              pattern: /-/
            },
            0: {
              multiple: !0,
              pattern: /[0-9]/
            }
          }
        };
      }
      return {
        postProcess: (e) => {
          if (e && typeof e < "u" && e !== "") {
            const t = this.getRealValue(
              String(e)
            ), i = Number(
              String(t).split(
                this.numberLocale === "en-US" ? "." : ","
              )[0]
            );
            if (this.maxDecimalPlaces) {
              if (!Number.isNaN(t)) {
                const a = String(e).split(
                  this.numberLocale === "en-US" ? "." : ","
                ), s = a[1];
                return (s == null ? void 0 : s.indexOf("0")) < 1 ? s.length > this.maxDecimalPlaces ? `${a[0]}${this.numberLocale === "en-US" ? "." : ","}${s.substring(
                  0,
                  this.maxDecimalPlaces
                )}` : e : Intl.NumberFormat(this.numberLocale, {
                  maximumFractionDigits: this.maxDecimalPlaces,
                  minimumFractionDigits: 0
                }).format(Number(t));
              }
            } else
              return Intl.NumberFormat(this.numberLocale, {
                maximumFractionDigits: this.maxDecimalPlaces,
                minimumFractionDigits: 0
              }).format(i);
          }
          return e || "";
        },
        preProcess: (e) => String(e).split(/[.,]/g)[0] === "" ? "" : String(e).replace(/[^0-9,.-]/gi, "")
      };
    },
    iconSortDown() {
      return P();
    },
    iconSortUp() {
      return M();
    },
    isFilled() {
      var e;
      return this.localValue !== null && typeof this.localValue < "u" ? typeof this.localValue != "number" ? this.localValue !== "" || ((e = this.localValue) == null ? void 0 : e.length) || Object.keys(this.localValue).length > 0 : !0 : !1;
    }
  },
  methods: {
    getRealValue(e) {
      if (!e || typeof e > "u")
        return null;
      if (e = String(e), this.withLocale) {
        if (this.numberLocale === "en-US" && e.split(".")[0] !== "" && e.split(".")[1] === "" || this.numberLocale === "id-ID" && e.split(",")[0] !== "" && e.split(",")[1] === "" || e === "-")
          return +"-";
      } else
        return e.split(".")[0] !== "" && e.split(".")[1] === "" ? +"-" : Number(e);
      return L(e, this.numberLocale);
    },
    handleBlur(e) {
      this.localIsFocus = !1;
      const t = this.getRealValue(
        this.localValue
      );
      e.target.value = Number.isNaN(t) ? this.localValue : Number(t), this.$emit("blur", e);
    },
    handleChange(e) {
      var i, a, s, p;
      const t = e;
      if (typeof ((i = t.detail) == null ? void 0 : i.unmasked) < "u") {
        const h = (a = t.detail) == null ? void 0 : a.unmasked, u = (s = t.detail) == null ? void 0 : s.masked, l = this.getRealValue(u);
        h === "" ? (t.target.value = (p = t.detail) == null ? void 0 : p.unmasked, this.isInvalidNumber = !1, this.$emit("input", e), this.$emit("update:modelValue", null)) : Number.isNaN(l) ? (this.isInvalidNumber = !0, this.$emit("input", e), this.$emit("update:modelValue", u)) : (t.target.value = l, this.isInvalidNumber = !1, this.$emit("input", e), this.$emit("update:modelValue", l));
      }
    },
    handleClickIcon(e) {
      var t;
      return ((t = this.icon) == null ? void 0 : t.onClick) && this.icon.onClick(e);
    },
    handleClickOutsideInput(e) {
      const t = e.target, i = this.$refs["input-wrapper"];
      t && i && !i.contains(t) && !t.isSameNode(i) && this.toggleFocus(!1);
    },
    handleClickStep(e) {
      const t = this.getRealValue(this.localValue) || 0, i = Number.isNaN(t) ? 0 : t + e;
      t > 0 && t < 1 && i < 0 ? this.localValue = 0 : typeof this.max < "u" && i > this.max ? this.localValue = this.max : typeof this.min < "u" && i < this.min ? this.localValue = this.min : this.withLocale && this.numberLocale === "id-ID" ? this.localValue = Intl.NumberFormat(this.numberLocale, {
        maximumFractionDigits: this.maxDecimalPlaces,
        minimumFractionDigits: 0
      }).format(Number(i)) : this.localValue = i;
    },
    handleErrorMessage() {
      return this.errorMessage ? typeof this.errorMessage == "string" ? this.errorMessage : this.errorMessage(this.localValue) : "";
    },
    handleInputChange(e) {
      const t = this.getRealValue(
        this.localValue
      );
      if (t !== null && typeof this.max < "u" && !Number.isNaN(t) && t > this.max)
        e.target.value = this.max, this.localValue = this.max, this.$emit("update:modelValue", this.max), this.$emit("change", e);
      else if (t !== null && typeof this.min < "u" && !Number.isNaN(t) && t < this.min)
        e.target.value = this.min, this.localValue = this.min, this.$emit("update:modelValue", this.min), this.$emit("change", e);
      else {
        const i = Number.isNaN(t) ? this.localValue : t;
        e.target.value = i, this.$emit("update:modelValue", i), this.$emit("change", e);
      }
    },
    handleInputFocus(e) {
      this.localIsFocus = !0, this.$emit("focus", e);
    },
    handleKeydown(e) {
      if (!this.maxDecimalPlaces && (e.key === "," || e.key === "."))
        e.preventDefault(), e.stopPropagation();
      else if (e.key === "ArrowUp")
        e.preventDefault(), e.stopPropagation(), this.handleClickStep(this.step);
      else if (e.key === "ArrowDown")
        e.preventDefault(), e.stopPropagation(), this.handleClickStep(this.step * -1);
      else if (this.maxDecimalPlaces && this.withLocale && (e.key === "," || e.key === ".")) {
        const t = String(this.localValue);
        if (t) {
          const i = e.target, a = i.selectionStart, s = i.selectionEnd;
          this.numberLocale === "en-US" && e.key === "," ? (e.preventDefault(), e.stopPropagation(), this.localValue = `${t.substr(
            0,
            a
          )}.${t.substr(s)}`, i.selectionEnd = s + 1) : this.numberLocale === "id-ID" && e.key === "." && (e.preventDefault(), e.stopPropagation(), this.localValue = `${t.substr(
            0,
            a
          )},${t.substr(s)}`, i.selectionEnd = s + 1);
        }
      }
      this.$emit("keydown", e);
    },
    handleMouseLeaveIcon(e) {
      var t;
      return ((t = this.icon) == null ? void 0 : t.onMouseLeave) && this.icon.onMouseLeave(e);
    },
    handleMouseOverIcon(e) {
      var t;
      return ((t = this.icon) == null ? void 0 : t.onMouseOver) && this.icon.onMouseOver(e);
    },
    handlePaste(e) {
      const i = (e.clipboardData || window.clipboardData).getData("Text");
      /^-?\d*[.,]?\d*$/.test(i) || e.preventDefault();
    },
    handleValueProp(e) {
      if (e !== null && typeof e < "u" && String(e) !== "" && this.withLocale && this.numberLocale === "id-ID" && !Number.isNaN(Number(e))) {
        const i = String(this.localValue).split(",")[1];
        if ((i == null ? void 0 : i.charAt(0)) !== "0") {
          const a = Intl.NumberFormat(
            this.numberLocale,
            {
              maximumFractionDigits: this.maxDecimalPlaces,
              minimumFractionDigits: 0
            }
          ).format(Number(e));
          this.localValue = a;
        }
      } else
        this.localValue = e;
    },
    toggleFocus(e, t) {
      if (t) {
        const i = t.target, a = i == null ? void 0 : i.querySelectorAll("input");
        a.length > 0 && a[0].focus();
      }
      this.localIsFocus = e;
    }
  },
  watch: {
    isFocus(e) {
      this.localIsFocus = e;
    },
    modelValue: {
      handler(e) {
        this.handleValueProp(e);
      }
    },
    value: {
      handler(e) {
        this.handleValueProp(e);
      }
    }
  },
  mounted() {
    document.addEventListener(
      "click",
      (e) => this.handleClickOutsideInput(e)
    );
  },
  unmounted() {
    document.removeEventListener(
      "click",
      (e) => this.handleClickOutsideInput(e)
    );
  }
});
const C = {
  key: 0,
  class: "asterisk"
}, q = ["autocomplete", "tabindex"], O = { class: "button-wrapper" }, B = { class: "input-border" }, E = { class: "notch" }, U = {
  key: 0,
  class: "asterisk"
}, A = {
  key: 0,
  class: "error-wrapper"
}, R = { key: 0 }, T = ["innerHTML"];
function j(e, t, i, a, s, p) {
  var u;
  const h = N("maska");
  return n(), o("div", f({
    class: ["input-wrapper number", { error: e.isError, flat: e.variant === "flat" }],
    ref: "input-wrapper"
  }, { ...e.$attrs }), [
    r("div", {
      class: d(["input-group", {
        disabled: e.disabled,
        filled: e.isFilled,
        focus: e.isFocus || e.localIsFocus,
        icon_prepend: !!e.icon || !!e.$slots["icon-slot"],
        readonly: e.readOnly
      }])
    }, [
      e.label ? (n(), o("label", {
        key: 0,
        class: d(["label", { required: e.required }])
      }, [
        r("span", null, c(e.label), 1),
        e.required ? (n(), o("span", C, "*")) : m("", !0)
      ], 2)) : m("", !0),
      e.icon || e.$slots["icon-slot"] ? (n(), o("span", {
        key: 1,
        class: d([{
          "sb-cursor-pointer": (u = e.icon) == null ? void 0 : u.onClick
        }, "icon"]),
        onClick: t[0] || (t[0] = k((...l) => e.handleClickIcon && e.handleClickIcon(...l), ["stop"])),
        onMouseover: t[1] || (t[1] = (...l) => e.handleMouseOverIcon && e.handleMouseOverIcon(...l)),
        onMouseleave: t[2] || (t[2] = (...l) => e.handleMouseLeaveIcon && e.handleMouseLeaveIcon(...l))
      }, [
        D(e.$slots, "icon-slot")
      ], 34)) : m("", !0),
      r("div", {
        class: d(["form-control", ["text", e.textAlign]]),
        onClick: t[10] || (t[10] = (l) => e.toggleFocus(!0, l))
      }, [
        S(r("input", f({
          autocomplete: e.autocomplete ? "on" : "off",
          tabindex: e.readOnly || e.disabled ? -1 : e.tabindex,
          type: "text",
          "onUpdate:modelValue": t[3] || (t[3] = (l) => e.localValue = l)
        }, {
          disabled: e.disabled,
          placeholder: e.placeholder,
          readonly: e.readOnly
        }, {
          onBlur: t[4] || (t[4] = (l) => e.handleBlur(l)),
          onFocus: t[5] || (t[5] = (l) => e.handleInputFocus(l)),
          onInput: t[6] || (t[6] = (l) => e.handleChange(l)),
          onKeydown: t[7] || (t[7] = (l) => e.handleKeydown(l)),
          onChange: t[8] || (t[8] = (l) => e.handleInputChange(l)),
          onPaste: t[9] || (t[9] = (...l) => e.handlePaste && e.handlePaste(...l))
        }), null, 16, q), [
          [h, void 0, e.getMaskaOptions],
          [I, e.localValue]
        ])
      ], 2),
      r("div", O, [
        r("div", {
          class: "button increment",
          onClick: t[11] || (t[11] = (l) => e.handleClickStep(e.step))
        }, [
          (n(), b(g(e.iconSortUp)))
        ]),
        r("div", {
          class: "button decrement",
          onClick: t[12] || (t[12] = (l) => e.handleClickStep(e.step * -1))
        }, [
          (n(), b(g(e.iconSortDown)))
        ])
      ]),
      r("fieldset", B, [
        r("legend", E, [
          r("span", {
            class: d(["notch-label", { "no-label": !e.label || e.label === "" }])
          }, [
            e.label && e.label !== "" ? (n(), o(y, { key: 0 }, [
              r("span", null, c(e.label), 1),
              e.required ? (n(), o("span", U, "*")) : m("", !0)
            ], 64)) : (n(), o(y, { key: 1 }, [
              $("​")
            ], 64))
          ], 2)
        ])
      ])
    ], 2),
    e.isInvalidNumber || e.isError && e.errorMessage ? (n(), o("div", A, [
      e.isInvalidNumber ? (n(), o("span", R, c(e.invalidNumberMessage), 1)) : (n(), o("span", {
        key: 1,
        innerHTML: e.handleErrorMessage()
      }, null, 8, T))
    ])) : m("", !0)
  ], 16);
}
const Q = /* @__PURE__ */ v(w, [["render", j]]);
export {
  Q as default
};
